#include <bits/stdc++.h>
using namespace std;

long long a[1007][1007],used[100007],cur[100007],d[100007],b,c,x,y,n,t,mi,m,k,p,l,r;
vector<long long>res;
map<long long, long long>mp;
set<long long>st;
int main() {


	int n;
	cin>>n>>m;
  for (int i=1; i<=m; i++){
        int v1,v2;
    cin>>v1>>v2;
    a[v1][v2]++;
    d[v1]++;
  }
    cout<<"NO"<<"\n";
}
